#define _CRT_SECURE_NO_DEPRECATE
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define	PAL(a)	(a << 9)

unsigned short map[32][32], wt;
unsigned char buffer[0x8000];

int	main(int argc, char **argv)
{
	int		x, y, w, h, n, i, size, tileoffset;
	char	filename[256];
	FILE	*in, *outgfx, *outmap, *outpal;

	printf("SwanLayer Merger - by Orion_ [2008] http://onorisoft.free.fr/\n\n");

	if (!(argc > 4))
	{
		printf("Usage: swanlayer width height file_prefix number_of_layer\n");
		system("PAUSE");
		return (-1);
	}

	w = atoi(argv[1]) / 8;
	h = atoi(argv[2]) / 8;
	n = atoi(argv[4]);
	sprintf(filename, "%s.gfx", argv[3]);
	outgfx = fopen(filename, "wb");
	sprintf(filename, "%s.map", argv[3]);
	outmap = fopen(filename, "wb");
	sprintf(filename, "%s.pal", argv[3]);
	outpal = fopen(filename, "wb");
	if (!outgfx || !outmap || !outpal)
	{
		printf("file creation error\n");
		return (-1);
	}

	memset(map, 0, sizeof(map));
	for (tileoffset = 0, i = 0; i < n; i++)
	{
		sprintf(filename, "%s%d.pal", argv[3], i + 1);
		in = fopen(filename, "rb");
		fread(buffer, 1, 32, in);
		fwrite(buffer, 1, 32, outpal);
		fclose(in);

		sprintf(filename, "%s%d.gfx", argv[3], i + 1);
		in = fopen(filename, "rb");
		fseek(in, 0, SEEK_END);
		size = ftell(in) - ((i == 0) ? (0) : (4 * 8));
		fseek(in, (i == 0) ? (0) : (4 * 8), SEEK_SET);
		fread(buffer, 1, size, in);
		fwrite(buffer, 1, size, outgfx);
		fclose(in);

		sprintf(filename, "%s%d.map", argv[3], i + 1);
		in = fopen(filename, "rb");
		for (y = 0; y < h; y++)
		{
			for (x = 0; x < w; x++)
			{
				fread(&wt, 2, 1, in);
				if (wt)	map[y][x] = ((wt + tileoffset) - ((i == 0) ? 0 : 1) ) | PAL(i);
			}
		}
		fclose(in);

		tileoffset += (size / (4 * 8));
	}
	for (i = 0; i < y; i++)
		fwrite(&map[i], 2, 32, outmap);

	fclose(outgfx);
	fclose(outmap);
	return (0);
}
